create trigger TR_LIGNESV_RESS_STOCK_INS
on dbo.LIGNES_V
FOR INSERT not for replication
AS
BEGIN

declare @info varchar(200)

/* VERIFICATION LIGNES_V.MOMENT1 OU LIGNES_V.MOMENT2 NON COMPLETES */

select @info=rtrim(stock.s_modele) from inserted inner join STOCK on (inserted.id_article=stock.s_id)
	where (stock.s_ress>' ') and ((inserted.moment1='01/01/1900') or (inserted.moment2='01/01/1900'))

if @info is not null
	begin
		set @info='Date de ressource non spcifie : '+@info+' !'
		ROLLBACK TRAN
		RAISERROR ( @info,16,1 )	
		RETURN
	end

/* VERIFICATION QUE TOUTES LES RESSOURCES "JOURS" UTILISEES EXISTENT */

select @info=rtrim(stock.s_modele)+' '+convert(char(10),inserted.moment1,103)+'-'+convert(char(10),inserted.moment2,103) from inserted inner join STOCK on (inserted.id_article=stock.s_id)  
	cross join DATES
	left join RESS on (ress.module='STOCK') and (inserted.id_article=ress.id_sig) and (dates.sequence=ress.moment1)
	where (stock.s_ress='J') and (dates.sequence>=dbo.ROUNDTIME(inserted.moment1,stock.s_ress)) and (dates.sequence<=dbo.ROUNDTIME(inserted.moment2,stock.s_ress)) and (ress.id is null) 

if @info is not null
	begin
		set @info='Ressource inexistante : '+@info+' !'
		ROLLBACK TRAN
		RAISERROR ( @info,16,1 )	
		RETURN
	end

/* VERIFICATION QUE TOUTES LES RESSOURCES "HEURES" UTILISEES EXISTENT */

select @info=rtrim(stock.s_modele)+' '+convert(char(10),inserted.moment1,103)+'-'+convert(char(10),inserted.moment2,103) from inserted inner join STOCK on (inserted.id_article=stock.s_id)  
	cross join HEURES
	left join RESS on (ress.module='STOCK') and (inserted.id_article=ress.id_sig) and (heures.sequence=ress.moment1)
	where (stock.s_ress='H') and (heures.sequence>=dbo.ROUNDTIME(inserted.moment1,stock.s_ress)) and (heures.sequence<=dbo.ROUNDTIME(inserted.moment2,stock.s_ress)) and (ress.id is null) 
	
if @info is not null
	begin
		set @info='Ressource inexistante : '+@info+' !'
		ROLLBACK TRAN
		RAISERROR ( @info,16,1 )	
		RETURN
	end

/* AJOUTS DES CONSOMMATIONS DE RESSOURCES PAR "JOURS" */

insert into RESSDATA (module,id_sig,id,id2,origine,q,couleur,texte)
	select 'STOCK',inserted.id_article,ress.id,right(newid(),10),'V_'+inserted.id+inserted.journal+str(inserted.piece,10)+inserted.dl_id,inserted.q,dbo.type_v(inserted.id,inserted.journal,inserted.piece),dbo.tiers_v(inserted.id,inserted.journal,inserted.piece)
	from inserted
	cross join DATES
	inner join RESS on (ress.module='STOCK') and (inserted.id_article=ress.id_sig) and (dates.sequence=ress.moment1)
	where (dates.sequence>=dbo.ROUNDTIME(inserted.moment1,ress.ress)) and (dates.sequence<=dbo.ROUNDTIME(inserted.moment2,ress.ress)) and (ress.ress='J') and (inserted.q<>0)

/* AJOUTS DES CONSOMMATIONS DE RESSOURCES PAR "HEURES" */

insert into RESSDATA (module,id_sig,id,id2,origine,q,couleur,texte)
	select 'STOCK',inserted.id_article,ress.id,right(newid(),10),'V_'+inserted.id+inserted.journal+str(inserted.piece,10)+inserted.dl_id,inserted.q,dbo.type_v(inserted.id,inserted.journal,inserted.piece),dbo.tiers_v(inserted.id,inserted.journal,inserted.piece)
	from inserted
	cross join HEURES
	inner join RESS on (ress.module='STOCK') and (inserted.id_article=ress.id_sig) and (heures.sequence=ress.moment1)
	where (heures.sequence>=dbo.ROUNDTIME(inserted.moment1,ress.ress)) and (heures.sequence<=dbo.ROUNDTIME(inserted.moment2,ress.ress)) and (ress.ress='H') and (inserted.q<>0)

/* ARRONDI DE MOMENT1 ET MOMENT2 DANS LIGNES_V EN FONCTION DE L'UNITE DE RESSOURCES */

update lignes_v
	set lignes_v.moment1=dbo.ROUNDTIME(lignes_v.moment1,stock.s_ress),lignes_v.moment2=dbo.ROUNDTIME(lignes_v.moment2,stock.s_ress)
	from inserted inner join stock on (inserted.id_article=stock.s_id)
	where (inserted.id=lignes_v.id) and (inserted.journal=lignes_v.journal) and (inserted.piece=lignes_v.piece) and (inserted.dl_id=lignes_v.dl_id) 
	and (stock.s_ress>' ')

END
